ad_page_contract {
    Administration page for intranet-search-oracle
    Main page
    
    @author Marc Baiges Camprub (tm08707@salleurl.edu)
} {

}

# ---------------------------------------------------------------------
# Defaults & Security
# ---------------------------------------------------------------------

set user_id [ad_maybe_redirect_for_registration]

# ---------------------------------------------------------------------
# List themes in im_ef_themes
# ---------------------------------------------------------------------
proc theme_list { } {
        set html "
                <table>
                <tr><td>
                        <ul>
        "
        # Go through all themes in the database
        set sql "select theme_name,theme_id from im_ef_themes order by theme_name"
	db_foreach get_themes $sql {
                append html "
                        <li> <b>$theme_name</b> <a href='ef_theme_edit?theme_id=$theme_id'>(Edit theme)</a>
                "
	}
        append html "
        </ul>
        <br>
        <a href='ef_theme_add.tcl'>Add new theme</a>
        </td></tr>
        </table>
"

    return $html
}


# ---------------------------------------------------------------------
# List the users profile according to themes 
# ---------------------------------------------------------------------
proc users_list { } {
        set html "
        	<table>
                <tr><td>
        	<ul>
        "
        set sql "select username,user_id from users where user_id in (select owner from im_ef_files)"
	db_foreach get_proj $sql {
                append html "
                	<li> <b>$username</b> <a href='ef_user_profile_calc.tcl?user_profile=$user_id'>(Calculate profile)</a> | <a href='ef_user_profile_view.tcl?user_profile=$user_id'>(View profile)</a>
                	<BR>
                	<table width='100%'>

                	</table>
                "
	}
	append html "
	</ul>
	</td></tr>
        </table>"
}


# ---------------------------------------------------------------------
# List projects (trained or not)
# ---------------------------------------------------------------------
proc proj_list { } {
        set html "
                <table>
                <tr><td>
                        <ul>
        "
        # Go through all projects not used yet
        set sql "select project_id,project_name from im_projects where project_id not in (select distinct project_id from im_ef_projects) order by project_name"
	db_foreach get_proj $sql {
                append html "
                        <li> <b>$project_name</b> <a href='ef_train_project.tcl?project_id=$project_id'>(Train project)</a>
                "
	}
        append html "
        </ul>
        <br> Already trained projects:
        <ul>
        "
        # Go through all projects already trained
        set sql "select project_id,project_name from im_projects where project_id in (select distinct project_id from im_ef_projects) order by project_name"
	db_foreach get_proj $sql {
                append html "
                        <li> <b>$project_name</b> <a href='ef_train_project.tcl?project_id=$project_id'> <a href='ef_training_info.tcl?project_id=$project_id'>(Training info)</a>
                "
	}
        append html "
        </ul>
        </td></tr>
        </table>
"

    return $html
}

# Compose the webpage
set page_body "
<table width='100%' cellpadding='5'>
<tr>
	<td width='100%' colspan='2' valign='top'>
		<form method='post' action='ef_search.tcl'>
		<center>
			<input type='text' width='25' name='search_query'>
			<input type='submit' value='Find'>
		</center>
		</form>
		<br>
	</td>
</tr>
<tr>
	<td width='50%' valign='top'>
		[im_table_with_title "EF Theme Manager" [theme_list]]
		<br>
		[im_table_with_title "Users' Profiles" [users_list]]
	</td>
	<td width='50%' valign='top'>
		[im_table_with_title "EF Data Source" [proj_list]]
	</td>
</tr>
</table>
"

doc_return  200 text/html [im_return_template]