ad_page_contract {
    Administration page for intranet-search-oracle
    Search page

    @param search_query		String with the words to be used as keywords for the search
    @author Marc Baiges Camprub (tm08707@salleurl.edu)
} {    
    search_query:notnull
}

# ---------------------------------------------------------------------
# Perform an expert search from a search query
# ---------------------------------------------------------------------
proc find_experts { search_q } {
	set html "<table width='100%'>"
	set keywords [split $search_q " "]
	set sql "select im_ef_search_query_seq.nextval as query_id from dual"
	db_1row select_queryid $sql
	
	# Split the query into its words and store them in a temp table, a simple way
	# to make this info visible to a PL/SQL function
	foreach kword $keywords {
		db_transaction {			
			db_dml kword_add {
				insert into im_ef_search_queries(query_id,word)
				values(:query_id,:kword)		
			}
		} 	
	}
	
	# Call the PL/SQL
	db_dml perform_query "
		begin
			im_ef_search.im_ef_search_experts(:query_id);
		end;
	"
	
	# Show the profile assigned to the query
	set sql "select * from im_ef_themes,im_ef_queries_profile 
			where im_ef_queries_profile.query_id = :query_id and
			im_ef_queries_profile.theme_id = im_ef_themes.theme_id"
	
	append html "
			<tr><td align='left' colspan='2'><b>Search query profile:</b><br></td></tr>
		"
	
	db_foreach temes $sql {
		append html "
			<tr><td align='left' width='100'><B>$theme_name</B>:</td> <td align='left' width='100'>$value</td></tr>
		"
	}
		
	# Show each user punctuation for the given query
	set sql "select im_ef_search_results.user_id,im_ef_search_results.value,users.username from im_ef_search_results,users
				 where query_id=:query_id and users.user_id = im_ef_search_results.user_id 
				 order by (value) asc "
	
	append html "<tr><td colspan='2'> <BR><BR></td></tr>"
	
	db_foreach get_results $sql {
		append html "<tr><td> - $username ($value) </td></tr>"
	}
	
	db_dml esborra_queryprofile "delete from im_ef_queries_profile where query_id=$query_id"
	db_dml esborra_results "delete from im_ef_search_results where query_id=$query_id"
	db_dml esborra_query "delete from im_ef_search_queries where query_id=$query_id"
	
	append html "</table>"
	
	return $html
}


# Compose the webpage
set page_body "
<table width='100%' cellpadding='5'>
<tr>
	<td width='100%' valign='top'>
		[im_table_with_title "Search Results" [find_experts $search_query]]
	</td>
</tr>
</table>
"

doc_return  200 text/html [im_return_template]