ad_page_contract {
    Administration page for intranet-search-oracle
    Shows the information extracted and assigned to a trained project

    @param project_id   The project to be trained
    @author Marc Baiges Camprub (tm08707@salleurl.edu)
} {    
    project_id
}

# ---------------------------------------------------------------------
# Defaults & Security
# ---------------------------------------------------------------------

set user_id [ad_maybe_redirect_for_registration]

# ---------------------------------------------------------------------
# List project's files that will be used to train the system and asks 
# for a proximity value for the project to each theme
# ---------------------------------------------------------------------
proc proj_train_list { p_id} {
	set files [im_filestorage_find_files $p_id]
        set html "
        				
                <table width='100%'>
                <tr><td align='right' width='100%'><a href='ef_admin.tcl'>Back</a></td></tr>
                <tr><td>
			Filestorage Path: [im_filestorage_project_path $p_id]<br><br>
			Files that have been trained with those weights assigned manually...			
	"
	
	set taula "<BR><BR><table width='200'>"
	set sql "select * from im_ef_projects,im_ef_themes where project_id=:p_id and im_ef_themes.theme_id = im_ef_projects.theme_id"
	db_foreach temes_projecte $sql {
		append taula "
			<tr><td align='left' width='100'><B>$theme_name</B>:</td> <td align='left' width='100'>$theme_prob_assigned</td></tr>
		"
	}
	append taula "</table><BR>"
	
	append html $taula
	
	append html "
			<ul>
	"
			foreach file $files {
				
				append html "
					<li>Postigns for the file $file					
					<UL>
				"
				set sql "select file_id from im_ef_files where path = '$file'"
				db_1row select_fileid $sql
				
				set sql "select keyword,occurrences from im_ef_postings where file_id = :file_id"
								
				db_foreach get_info_proj $sql {					
					append html "<li> <B>$keyword</B>: $occurrences occurrences"
				}
				
				append html "</UL><BR>"
				
			}
	append html "
			</ul>
		</td></tr>
	        </table>
	        
	"

    return $html
}


# Compose the webpage
set page_body "
<table width='100%' cellpadding='5'>
<tr>
	<td width='100%' valign='top'>
		[im_table_with_title "EF Data Source" [proj_train_list $project_id]]
	</td>
</tr>
</table>
"

doc_return  200 text/html [im_return_template]