ad_page_contract {
    Administration page for intranet-search-oracle
    Shows a user's calculated profile

    @param user_profile   The user we want to show its profile
    @author Marc Baiges Camprub (tm08707@salleurl.edu)
} {    
    user_profile:notnull
}

# ---------------------------------------------------------------------
# Defaults & Security
# ---------------------------------------------------------------------

set user_id [ad_maybe_redirect_for_registration]


# ---------------------------------------------------------------------
# List the user's profile, with probability values to each theme for 
# the given user
# ---------------------------------------------------------------------
proc user_profile_list { u_id} {
	set html "<table width='100%'>
                <tr><td align='right' width='100%'><a href='ef_admin.tcl'>Back</a></td></tr>"
		
	set sql "select * from im_ef_users,im_ef_themes where 
						im_ef_users.user_id = :u_id and
						im_ef_themes.theme_id=im_ef_users.theme_id
						order by(theme_prob_assigned) desc"
	
	db_foreach temes_projecte $sql {
		append html "
			<tr><td align='left' width='100'><b>$theme_name</b>: $theme_prob_assigned</td></tr>
		"
	}

	append html "</table>"

  return $html
}


# Compose the webpage
set page_body "
<table width='100%' cellpadding='5'>
<tr>
	<td width='100%' valign='top'>
		[im_table_with_title "User Profile" [user_profile_list $user_profile]]
	</td>
</tr>
</table>
"

doc_return  200 text/html [im_return_template]